//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "Unit2.h"
#include "Unit3.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
bool WriteTo()
{DWORD temp;

 WriteFile(Port,wr_buf,wr_buf_len,&temp,&ovr_wr); //   
 WaitForSingleObject(ovr_wr.hEvent,30000);        //   30         
 if(GetOverlappedResult(Port,&ovr_wr,&temp,true)) return true;  //    -  
 else                                             return false; //  - 
}
//---------------------------------------------------------------------------
bool ReadFrom()
{ COMSTAT    port_status;
  DWORD      temp, mask;
  int        Counter;

 Counter=0;
 while(Counter<1000) //   1000 
 { ClearCommError(Port,&temp,&port_status);    //  port_status
   rd_buf_len=0;
   rd_buf_len=port_status.cbInQue;  //-  
   if(rd_buf_len)
   { ReadFile(Port,rd_buf,rd_buf_len,&temp,&ovr_rd);  //  - 
     return true;
   }
   Counter++;
   Sleep(1);
 }
 return false;
}
//---------------------------------------------------------------------------
void OpenPort()
{ dcb.DCBlength=sizeof(DCB);
  //  .     nt-  
  // "\\.\PortName",      \    2 
  char PortName[100]="\\\\.\\";
  strcat(PortName,Form1->ComboBox1->Text.c_str());
  Port=CreateFile(PortName,GENERIC_READ|GENERIC_WRITE,0,NULL,OPEN_EXISTING,FILE_FLAG_OVERLAPPED,NULL);
  if(Port==INVALID_HANDLE_VALUE)
  { MessageBox(NULL,"  ","Error",MB_OK);
    return;
  }
  else
  { if(GetCommState(Port,&dcb)==0)
    { MessageBox(NULL,"   ","Error",MB_OK);
      CloseHandle(Port);
      Port=INVALID_HANDLE_VALUE;
      return;
    }
    else
    { dcb.BaudRate=115200;
      dcb.ByteSize=8;
      dcb.Parity=0;
      dcb.StopBits=2;
      dcb.fBinary=true;          //  
      dcb.fOutxCtsFlow=false;    //  CTS
      dcb.fOutxDsrFlow=false;    //  DSR
      dcb.fDtrControl=DTR_CONTROL_DISABLE;     // DTR
      dcb.fDsrSensitivity=false;               //  DSR
      dcb.fNull=false;           //  
      dcb.fRtsControl=RTS_CONTROL_DISABLE;    // RTS
      dcb.fAbortOnError=false;   //  /  
   }
   if(SetCommState(Port,&dcb)==0)
   { MessageBox(NULL,"   ","Error",MB_OK);
     CloseHandle(Port);
     Port=INVALID_HANDLE_VALUE;
     return;
   }

   memset(wr_buf,0,BUFSIZE);        //    
   wr_buf_len=0;                    //  
   SetupComm(Port,BUFSIZE+100,BUFSIZE+100);       //    
   PurgeComm(Port,PURGE_RXCLEAR|PURGE_TXCLEAR);   //     

   Form1->Button1->Enabled=true;
   Form1->Button2->Enabled=true;
   Form1->Button3->Enabled=false;
   Form1->Button4->Enabled=true;

   //  
   wr_buf_len=3;
   wr_buf[0]=0x0A;     // disable autoload
   wr_buf[1]=0x08;     // disable reports
   wr_buf[2]=0x01;     // select I2C
   if(!WriteTo())
   { MessageBox(NULL,"  ","Error",MB_OK);
     ClosePort();
   }
  }
}
//---------------------------------------------------------------------------
void ClosePort()
{ CloseHandle(Port);
  Port=INVALID_HANDLE_VALUE;
  Form1->Button1->Enabled=false;
  Form1->Button2->Enabled=false;
  Form1->Button3->Enabled=true;
  Form1->Button4->Enabled=false;
}
//---------------------------------------------------------------------------
void BuildMemory()
{ int i; AnsiString Temp;
  //  1,2,3
  Form1->RichEdit1->Clear(); Form1->RichEdit2->Clear(); Form1->RichEdit3->Clear();
  Form1->RichEdit1->Visible=false; Form1->RichEdit2->Visible=false; Form1->RichEdit3->Visible=false;
  // -
  Application->CreateForm(__classid(TLBar),&LBar); //    -
  LBar->Show();                   //     
  //    
  for(i=0; i<SelectedChip.Size/8 ; i++)
   { Form1->RichEdit1->Lines->Add(IntToHex(8*i,4)+": FF FF FF FF FF FF FF FF   |   ");
     Form1->RichEdit2->Lines->Add(IntToHex(8*i,4)+": FF FF FF FF FF FF FF FF   |   ");
     Form1->RichEdit3->Lines->Add(IntToHex(8*i,4)+": FF FF FF FF FF FF FF FF   |   ");
     LBar->ProgressBar1->Position=100*8*i/SelectedChip.Size; //    -
   }
  //     
  Form1->RichEdit1->SelStart=46*(i-1)+44;
  Form1->RichEdit1->SelLength=2;
  Form1->RichEdit1->SelText="";
  Form1->RichEdit2->SelStart=46*(i-1)+44;
  Form1->RichEdit2->SelLength=2;
  Form1->RichEdit2->SelText="";
  Form1->RichEdit3->SelStart=46*(i-1)+44;
  Form1->RichEdit3->SelLength=2;
  Form1->RichEdit3->SelText="";
  // /  
  if(SelectedChip.PWrite==true)
  { Form1->CheckBox2->Enabled=true;
    Form1->CheckBox2->Checked=true;
  }
  else
  { Form1->CheckBox2->Checked=false;
    Form1->CheckBox2->Enabled=false;
  }
  //  -
  LBar->Free();        //    -
  //   hipName    
  Form1->Edit1->Text=SelectedChip.Name;
  Form1->RichEdit1->Visible=true; Form1->RichEdit2->Visible=true; Form1->RichEdit3->Visible=true;
  FilePath="";
  Form1->StaticText1->Caption=FilePath;
}
//---------------------------------------------------------------------------
void ChangeLeftRight(int PositionGlobal, int PositionLocal, int LineNumber, char Key)
{ int  TempPositionGlobalR, TempPositionGlobalL;
  bool ChangeLeft, ChangeRight;
  AnsiString TempStr;
  char buf[2], value[1], hexbuf[3];
  unsigned char TempChar;
  char *Charset1="0123456789abcdefABCDEF";

 ChangeLeft=false; ChangeRight=false;
 switch(PositionLocal)
  { case 6: case 7:   TempPositionGlobalR=LineNumber*46+36; //   ,    
                      TempPositionGlobalL=46*LineNumber+6;  //   ,       
                      ChangeLeft=true; //   
                      break;
    case 9: case 10:  TempPositionGlobalR=LineNumber*46+37; //   ,    
                      TempPositionGlobalL=46*LineNumber+9;  //   ,       
                      ChangeLeft=true; //   
                      break;
    case 12: case 13: TempPositionGlobalR=LineNumber*46+38; //   ,    
                      TempPositionGlobalL=46*LineNumber+12; //   ,       
                      ChangeLeft=true; //   
                      break;
    case 15: case 16: TempPositionGlobalR=LineNumber*46+39; //   ,    
                      TempPositionGlobalL=46*LineNumber+15; //   ,       
                      ChangeLeft=true; //   
                      break;
    case 18: case 19: TempPositionGlobalR=LineNumber*46+40; //   ,    
                      TempPositionGlobalL=46*LineNumber+18; //   ,       
                      ChangeLeft=true; //   
                      break;
    case 21: case 22: TempPositionGlobalR=LineNumber*46+41; //   ,    
                      TempPositionGlobalL=46*LineNumber+21; //   ,       
                      ChangeLeft=true; //   
                      break;
    case 24: case 25: TempPositionGlobalR=LineNumber*46+42; //   ,    
                      TempPositionGlobalL=46*LineNumber+24; //   ,       
                      ChangeLeft=true; //   
                      break;
    case 27: case 28: TempPositionGlobalR=LineNumber*46+43; //   ,    
                      TempPositionGlobalL=46*LineNumber+27; //   ,       
                      ChangeLeft=true; //   
                      break;
    case 36: TempPositionGlobalR=LineNumber*46+36; //   ,    
             TempPositionGlobalL=46*LineNumber+6;  //   ,       
             ChangeRight=true; //   
             break;
    case 37: TempPositionGlobalR=LineNumber*46+37; //   ,    
             TempPositionGlobalL=46*LineNumber+9;  //   ,       
             ChangeRight=true; //   
             break;
    case 38: TempPositionGlobalR=LineNumber*46+38; //   ,    
             TempPositionGlobalL=46*LineNumber+12; //   ,       
             ChangeRight=true; //   
             break;
    case 39: TempPositionGlobalR=LineNumber*46+39; //   ,    
             TempPositionGlobalL=46*LineNumber+15; //   ,       
             ChangeRight=true; //   
             break;
    case 40: TempPositionGlobalR=LineNumber*46+40; //   ,    
             TempPositionGlobalL=46*LineNumber+18; //   ,       
             ChangeRight=true; //   
             break;
    case 41: TempPositionGlobalR=LineNumber*46+41; //   ,    
             TempPositionGlobalL=46*LineNumber+21; //   ,       
             ChangeRight=true; //   
             break;
    case 42: TempPositionGlobalR=LineNumber*46+42; //   ,    
             TempPositionGlobalL=46*LineNumber+24; //   ,       
             ChangeRight=true; //   
             break;
    case 43: TempPositionGlobalR=LineNumber*46+43; //   ,    
             TempPositionGlobalL=46*LineNumber+27; //   ,       
             ChangeRight=true; //   
             break;
  }
  bool Choice = (strchr(Charset1,Key))||(BS_FLAG);
  if(ChangeLeft && Choice)
  { //    
    if(Key==0x2E||BS_FLAG==true) Key=0x46;                    //   -   "F"
    switch(Form1->PageControl1->TabIndex)
    { case 0: Form1->RichEdit1->SelStart=PositionGlobal;      //     
              Form1->RichEdit1->SelLength=1;                  //  1 
              Form1->RichEdit1->SelText=Key;                  // 
              Form1->RichEdit1->SelStart=PositionGlobal;      //     
              Form1->RichEdit1->SelLength=1;                  //  1 
              Form1->RichEdit1->SelText=UpperCase(Form1->RichEdit1->SelText);//      
              //    
              Form1->RichEdit1->SelStart=TempPositionGlobalL; //     
              Form1->RichEdit1->SelLength=2;                  //  2 
              TempStr=LowerCase(Form1->RichEdit1->SelText);   //    
              break;
      case 1: Form1->RichEdit2->SelStart=PositionGlobal;      //     
              Form1->RichEdit2->SelLength=1;                  //  1 
              Form1->RichEdit2->SelText=Key;                  // 
              Form1->RichEdit2->SelStart=PositionGlobal;      //     
              Form1->RichEdit2->SelLength=1;                  //  1 
              Form1->RichEdit2->SelText=UpperCase(Form1->RichEdit2->SelText);//      
              //    
              Form1->RichEdit2->SelStart=TempPositionGlobalL; //     
              Form1->RichEdit2->SelLength=2;                  //  2 
              TempStr=LowerCase(Form1->RichEdit2->SelText);   //    
              break;
      case 2: Form1->RichEdit3->SelStart=PositionGlobal;      //     
              Form1->RichEdit3->SelLength=1;                  //  1 
              Form1->RichEdit3->SelText=Key;                  // 
              Form1->RichEdit3->SelStart=PositionGlobal;      //     
              Form1->RichEdit3->SelLength=1;                  //  1 
              Form1->RichEdit3->SelText=UpperCase(Form1->RichEdit3->SelText);//      
              //    
              Form1->RichEdit3->SelStart=TempPositionGlobalL; //     
              Form1->RichEdit3->SelLength=2;                  //  2 
              TempStr=LowerCase(Form1->RichEdit3->SelText);   //    
    }
    memset(buf,0,2);                                //  
    strcat(buf,TempStr.c_str());                    //      (  )
    HexToBin(buf,value,1);                          //    ()
    TempChar=value[0];
    if(TempChar<0x1F) value[0]=0x1F; // 
    switch(Form1->PageControl1->TabIndex)
    { case 0: //    
              Form1->RichEdit1->SelStart=TempPositionGlobalR; //     
              Form1->RichEdit1->SelLength=1;                  //  1 
              Form1->RichEdit1->SelText=value[0];             //    value
              //    
              Form1->RichEdit1->SelStart=PositionGlobal;      //     
              Form1->RichEdit1->SelLength=0;                  //  
              break;
      case 1: //    
              Form1->RichEdit2->SelStart=TempPositionGlobalR; //     
              Form1->RichEdit2->SelLength=1;                  //  1 
              Form1->RichEdit2->SelText=value[0];             //    value
              //    
              Form1->RichEdit2->SelStart=PositionGlobal;      //     
              Form1->RichEdit2->SelLength=0;                  //  
              break;
      case 2: //    
              Form1->RichEdit3->SelStart=TempPositionGlobalR; //     
              Form1->RichEdit3->SelLength=1;                  //  1 
              Form1->RichEdit3->SelText=value[0];             //    value
              //    
              Form1->RichEdit3->SelStart=PositionGlobal;      //     
              Form1->RichEdit3->SelLength=0;                  //  
    }
  }
  if(ChangeRight)
  { if(Key==0x2E||BS_FLAG==true) Key=0xFF;                   //   -   ""
    switch(Form1->PageControl1->TabIndex)
    { case 0: //    
              Form1->RichEdit1->SelStart=PositionGlobal;     //     
              Form1->RichEdit1->SelLength=1;                 //  1 
              Form1->RichEdit1->SelText=Key;                 // 
              break;
      case 1: //    
              Form1->RichEdit2->SelStart=PositionGlobal;     //     
              Form1->RichEdit2->SelLength=1;                 //  1 
              Form1->RichEdit2->SelText=Key;                 // 
              break;
      case 2: //    
              Form1->RichEdit3->SelStart=PositionGlobal;     //     
              Form1->RichEdit3->SelLength=1;                 //  1 
              Form1->RichEdit3->SelText=Key;                 // 
    }
    //   
    value[0]=Key;
    BinToHex(value,hexbuf,1);                      //    ()
    hexbuf[2]=0;                                   //   
    switch(Form1->PageControl1->TabIndex)
    { case 0: Form1->RichEdit1->SelStart=TempPositionGlobalL;//     
              Form1->RichEdit1->SelLength=2;                 //  1 
              Form1->RichEdit1->SelText=hexbuf;              //   hexbuf (2   -,    )
              Form1->RichEdit1->SelStart=PositionGlobal;     //    
              Form1->RichEdit1->SelLength=0;                 //  
              break;
      case 1: Form1->RichEdit2->SelStart=TempPositionGlobalL;//     
              Form1->RichEdit2->SelLength=2;                 //  1 
              Form1->RichEdit2->SelText=hexbuf;              //   hexbuf (2   -,    )
              Form1->RichEdit2->SelStart=PositionGlobal;     //    
              Form1->RichEdit2->SelLength=0;                 //  
              break;
      case 2: Form1->RichEdit3->SelStart=TempPositionGlobalL;//     
              Form1->RichEdit3->SelLength=2;                 //  1 
              Form1->RichEdit3->SelText=hexbuf;              //   hexbuf (2   -,    )
              Form1->RichEdit3->SelStart=PositionGlobal;     //    
              Form1->RichEdit3->SelLength=0;                 //  
    }
  }
}
//---------------------------------------------------------------------------
void LoadHexFile()
{ AnsiString tempstr, tempsubstr;
  unsigned char *hexbuf, tempbuf[1];
  char Symbol[2];
  unsigned int i, j, n, templinenumber, templocaladdr,
               Reclen, Offset, Rectyp, position,
               LinearBaseAddress, SegmentBaseAddress;
  int Address;

  LinearBaseAddress=0;
  SegmentBaseAddress=0;

  n=Form1->Memo1->Lines->Count;//   
  for(i=0;i<n;i++)
  { tempstr=Form1->Memo1->Lines->Strings[i];
    //- - 
    tempsubstr=tempstr.SubString(2,2);//- -     
    hexbuf=tempsubstr.c_str();
    HexToBin(hexbuf,tempbuf,1);
    Reclen=tempbuf[0];
    //   
    tempsubstr=tempstr.SubString(4,4);//    
    hexbuf=tempsubstr.c_str();
    HexToBin(hexbuf,tempbuf,2);
    Offset=tempbuf[0]*256+tempbuf[1];
    //  
    tempsubstr=tempstr.SubString(8,2);//     
    hexbuf=tempsubstr.c_str();
    HexToBin(hexbuf,tempbuf,1);
    Rectyp=tempbuf[0];
    switch(Rectyp)
    { //Data record
      case 0:
      for(j=0;j<Reclen;j++)
      { tempsubstr=tempstr.SubString(10+2*j,2);
        Address=LinearBaseAddress+SegmentBaseAddress+Offset+j;// 

        if(Address<SelectedChip.Size)
        { templinenumber=Address/8;                // ,    
          templocaladdr=Address-8*templinenumber;  //   
          //if(SelectedChip.AddrSize==2)//   2 
          //{ if(templocaladdr&1)       //     ,       ( ,  )
          //       { templocaladdr-=1; }//  ,   1
          //  else { templocaladdr+=1; }//  -  1
          //}
          hexbuf=tempsubstr.c_str();           // tempsubstr -     hex (  )
          HexToBin(hexbuf,tempbuf,1);
          if(tempbuf[0]<0x1F) tempbuf[0]=0x1F; // tempbuf[0] -      (  )
          Symbol[0]=tempbuf[0]; Symbol[1]=0;
          //   
          switch(Form1->PageControl1->TabIndex)
          { case 0: Form1->RichEdit1->SelStart=templinenumber*46+36+templocaladdr; //     
                    Form1->RichEdit1->SelLength=1;         //  1 
                    Form1->RichEdit1->SelText=Symbol[0];   // 
                    Form1->RichEdit1->SelLength=0;
                    break;
            case 1: Form1->RichEdit2->SelStart=templinenumber*46+36+templocaladdr; //     
                    Form1->RichEdit2->SelLength=1;          //  1 
                    Form1->RichEdit2->SelText=Symbol[0];   // 
                    Form1->RichEdit2->SelLength=0;
                    break;
            case 2: Form1->RichEdit3->SelStart=templinenumber*46+36+templocaladdr; //     
                    Form1->RichEdit3->SelLength=1;          //  1 
                    Form1->RichEdit3->SelText=Symbol[0];   // 
                    Form1->RichEdit3->SelLength=0;
          }
          //   
          switch(Form1->PageControl1->TabIndex)
          { case 0: Form1->RichEdit1->SelStart=templinenumber*46+6+3*templocaladdr;//     
                    Form1->RichEdit1->SelLength=2;                 //  1 
                    Form1->RichEdit1->SelText=tempsubstr;          //   hexbuf (2   -,    )
                    Form1->RichEdit1->SelStart=6;                  //    
                    Form1->RichEdit1->SelLength=0;                 //  
                    break;
            case 1: Form1->RichEdit2->SelStart=templinenumber*46+6+3*templocaladdr;//     
                    Form1->RichEdit2->SelLength=2;                 //  1 
                    Form1->RichEdit2->SelText=tempsubstr;          //   hexbuf (2   -,    )
                    Form1->RichEdit2->SelStart=6;                  //    
                    Form1->RichEdit2->SelLength=0;                 //  
                    break;
            case 2: Form1->RichEdit3->SelStart=templinenumber*46+6+3*templocaladdr;//     
                    Form1->RichEdit3->SelLength=2;                 //  1 
                    Form1->RichEdit3->SelText=tempsubstr;          //   hexbuf (2   -,    )
                    Form1->RichEdit3->SelStart=6;                  //    
                    Form1->RichEdit3->SelLength=0;                 //  
          }
        }
      }
      break;
      //End of file record
      case 1: Form1->StaticText1->Caption=FilePath;
              return;
      //Extended segment address record
      case 2: tempsubstr=tempstr.SubString(10,4);//     
              hexbuf=tempsubstr.c_str();
              HexToBin(hexbuf,tempbuf,2);
              SegmentBaseAddress=(tempbuf[0]*256+tempbuf[1])*16;
              break;
      //Start segment address record (  4-19   
      // ,       )
      case 3: MessageBox(NULL," HEX-  8086/80186","Error",MB_OK);
              return;
      //Extended linear address record (  2    
      // ,       )
      case 4: tempsubstr=tempstr.SubString(10,4);//     
              hexbuf=tempsubstr.c_str();
              HexToBin(hexbuf,tempbuf,2);
              LinearBaseAddress=(tempbuf[0]*256+tempbuf[1])*65536;
              break;
      //Start linear address record
      case 5: MessageBox(NULL," HEX-  80386","Error",MB_OK);
              return;
      //       - 
      default:MessageBox(NULL,"  !","Error",MB_OK);
              return;
    }
  }
  MessageBox(NULL,"   ","Error",MB_OK);
}
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{ Form1->AutoSize=true;
  Button1->Enabled=false;
  Button2->Enabled=false;
  Button3->Enabled=true;
  Button4->Enabled=false;
  SelectedChip.Name="AT24C02"; SelectedChip.Model=2; SelectedChip.Size=256;
  SelectedChip.AddrSize=1; SelectedChip.PageSize=8; SelectedChip.Banks=1;
  SelectedChip.PWrite=true; //   
  BuildMemory();
  if(FileExists("i2c_prog_1.jpg")) Image1->Picture->LoadFromFile("i2c_prog_1.jpg");
  else                           { MessageBox(NULL,"   ,\n(   ).  \n ,    \n   radiohlam.ru","Error",MB_OK);
                                   Image1->Picture->Bitmap->FreeImage(); }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button3Click(TObject *Sender)
{ OpenPort();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button4Click(TObject *Sender)
{ ClosePort();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ComboBox1Change(TObject *Sender)
{ //   ,    
  if(Port!=INVALID_HANDLE_VALUE) ClosePort();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Exit1Click(TObject *Sender)
{ if(Port!=INVALID_HANDLE_VALUE) ClosePort();
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::About1Click(TObject *Sender)
{ AboutBox->Show();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::X24C011Click(TObject *Sender)
{ SelectedChip.Name="X24C01"; SelectedChip.Model=0; SelectedChip.Size=128;
  SelectedChip.AddrSize=1; SelectedChip.PageSize=8; SelectedChip.Banks=1;
  SelectedChip.PWrite=true; //   
  BuildMemory();
  if(FileExists("i2c_prog_1.jpg")) Image1->Picture->LoadFromFile("i2c_prog_1.jpg");
  else                           { MessageBox(NULL,"   ,\n(   ).  \n ,    \n   radiohlam.ru","Error",MB_OK);
                                   Image1->Picture->Bitmap->FreeImage(); }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::N24C011Click(TObject *Sender)
{ SelectedChip.Name="AT24C01A"; SelectedChip.Model=1; SelectedChip.Size=128;
  SelectedChip.AddrSize=1; SelectedChip.PageSize=8; SelectedChip.Banks=1;
  SelectedChip.PWrite=true; //   
  BuildMemory();
  if(FileExists("i2c_prog_1.jpg")) Image1->Picture->LoadFromFile("i2c_prog_1.jpg");
  else                           { MessageBox(NULL,"   ,\n(   ).  \n ,    \n   radiohlam.ru","Error",MB_OK);
                                   Image1->Picture->Bitmap->FreeImage(); }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::N24C021Click(TObject *Sender)
{ SelectedChip.Name="AT24C02"; SelectedChip.Model=2; SelectedChip.Size=256;
  SelectedChip.AddrSize=1; SelectedChip.PageSize=8; SelectedChip.Banks=1;
  SelectedChip.PWrite=true; //   
  BuildMemory();
  if(FileExists("i2c_prog_1.jpg")) Image1->Picture->LoadFromFile("i2c_prog_1.jpg");
  else                           { MessageBox(NULL,"   ,\n(   ).  \n ,    \n   radiohlam.ru","Error",MB_OK);
                                   Image1->Picture->Bitmap->FreeImage(); }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::N24C041Click(TObject *Sender)
{ SelectedChip.Name="AT24C04"; SelectedChip.Model=3; SelectedChip.Size=512;
  SelectedChip.AddrSize=1; SelectedChip.PageSize=16; SelectedChip.Banks=2;
  SelectedChip.PWrite=true; //   
  BuildMemory();
  if(FileExists("i2c_prog_1.jpg")) Image1->Picture->LoadFromFile("i2c_prog_1.jpg");
  else                           { MessageBox(NULL,"   ,\n(   ).  \n ,    \n   radiohlam.ru","Error",MB_OK);
                                   Image1->Picture->Bitmap->FreeImage(); }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::N24C081Click(TObject *Sender)
{ SelectedChip.Name="AT24C08A"; SelectedChip.Model=4; SelectedChip.Size=1024;
  SelectedChip.AddrSize=1; SelectedChip.PageSize=16; SelectedChip.Banks=4;
  SelectedChip.PWrite=true; //   
  BuildMemory();
  if(FileExists("i2c_prog_1.jpg")) Image1->Picture->LoadFromFile("i2c_prog_1.jpg");
  else                           { MessageBox(NULL,"   ,\n(   ).  \n ,    \n   radiohlam.ru","Error",MB_OK);
                                   Image1->Picture->Bitmap->FreeImage(); }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::N24C161Click(TObject *Sender)
{ SelectedChip.Name="AT24C16A"; SelectedChip.Model=5; SelectedChip.Size=2048;
  SelectedChip.AddrSize=1; SelectedChip.PageSize=16; SelectedChip.Banks=8;
  SelectedChip.PWrite=true; //   
  BuildMemory();
  if(FileExists("i2c_prog_1.jpg")) Image1->Picture->LoadFromFile("i2c_prog_1.jpg");
  else                           { MessageBox(NULL,"   ,\n(   ).  \n ,    \n   radiohlam.ru","Error",MB_OK);
                                   Image1->Picture->Bitmap->FreeImage(); }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SDA25161Click(TObject *Sender)
{ SelectedChip.Name="SDA2516"; SelectedChip.Model=6; SelectedChip.Size=128;
  SelectedChip.AddrSize=1; SelectedChip.PageSize=1; SelectedChip.Banks=1;
  SelectedChip.PWrite=false; //   
  BuildMemory(); //   SDA2516 CS0    1
  if(FileExists("i2c_prog_2.jpg")) Image1->Picture->LoadFromFile("i2c_prog_2.jpg");
  else                           { MessageBox(NULL,"   ,\n(   ).  \n ,    \n   radiohlam.ru","Error",MB_OK);
                                   Image1->Picture->Bitmap->FreeImage(); }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SDA25261Click(TObject *Sender)
{ SelectedChip.Name="SDA2526"; SelectedChip.Model=7; SelectedChip.Size=256;
  SelectedChip.AddrSize=1; SelectedChip.PageSize=1; SelectedChip.Banks=1;
  SelectedChip.PWrite=false; //   
  BuildMemory(); //   SDA2526 CS0    1
  if(FileExists("i2c_prog_2.jpg")) Image1->Picture->LoadFromFile("i2c_prog_2.jpg");
  else                           { MessageBox(NULL,"   ,\n(   ).  \n ,    \n   radiohlam.ru","Error",MB_OK);
                                   Image1->Picture->Bitmap->FreeImage(); }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SDA25461Click(TObject *Sender)
{ SelectedChip.Name="SDA2546"; SelectedChip.Model=8; SelectedChip.Size=512;
  SelectedChip.AddrSize=1; SelectedChip.PageSize=1; SelectedChip.Banks=2;
  SelectedChip.PWrite=false; //   
  BuildMemory(); //   SDA2546 CS    1 (   )
  if(FileExists("i2c_prog_2.jpg")) Image1->Picture->LoadFromFile("i2c_prog_2.jpg");
  else                           { MessageBox(NULL,"   ,\n(   ).  \n ,    \n   radiohlam.ru","Error",MB_OK);
                                   Image1->Picture->Bitmap->FreeImage(); }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SDA25861Click(TObject *Sender)
{ SelectedChip.Name="SDA2586"; SelectedChip.Model=9; SelectedChip.Size=1024;
  SelectedChip.AddrSize=1; SelectedChip.PageSize=1; SelectedChip.Banks=4;
  SelectedChip.PWrite=false; //   
  BuildMemory(); //   SDA2546 CS    1 (   )
  if(FileExists("i2c_prog_2.jpg")) Image1->Picture->LoadFromFile("i2c_prog_2.jpg");
  else                           { MessageBox(NULL,"   ,\n(   ).  \n ,    \n   radiohlam.ru","Error",MB_OK);
                                   Image1->Picture->Bitmap->FreeImage(); }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SDA35261Click(TObject *Sender)
{ SelectedChip.Name="SDA3526"; SelectedChip.Model=10; SelectedChip.Size=256;
  SelectedChip.AddrSize=1; SelectedChip.PageSize=1; SelectedChip.Banks=1;
  SelectedChip.PWrite=false; //   
  BuildMemory(); //   SDA2526 CS0    1
  if(FileExists("i2c_prog_2.jpg")) Image1->Picture->LoadFromFile("i2c_prog_2.jpg");
  else                           { MessageBox(NULL,"   ,\n(   ).  \n ,    \n   radiohlam.ru","Error",MB_OK);
                                   Image1->Picture->Bitmap->FreeImage(); }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::N2425E161Click(TObject *Sender)
{ SelectedChip.Name="AT24C32"; SelectedChip.Model=19; SelectedChip.Size=2048;
  SelectedChip.AddrSize=2; SelectedChip.PageSize=8; SelectedChip.Banks=1;
  SelectedChip.PWrite=true; //   
  BuildMemory();
  if(FileExists("i2c_prog_1.jpg")) Image1->Picture->LoadFromFile("i2c_prog_1.jpg");
  else                           { MessageBox(NULL,"   ,\n(   ).  \n ,    \n   radiohlam.ru","Error",MB_OK);
                                   Image1->Picture->Bitmap->FreeImage(); }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::N24C321Click(TObject *Sender)
{ SelectedChip.Name="AT24C32"; SelectedChip.Model=11; SelectedChip.Size=4096;
  SelectedChip.AddrSize=2; SelectedChip.PageSize=32; SelectedChip.Banks=1;
  SelectedChip.PWrite=true; //   
  BuildMemory();
  if(FileExists("i2c_prog_1.jpg")) Image1->Picture->LoadFromFile("i2c_prog_1.jpg");
  else                           { MessageBox(NULL,"   ,\n(   ).  \n ,    \n   radiohlam.ru","Error",MB_OK);
                                   Image1->Picture->Bitmap->FreeImage(); }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::N24C641Click(TObject *Sender)
{ SelectedChip.Name="AT24C64"; SelectedChip.Model=12; SelectedChip.Size=8192;
  SelectedChip.AddrSize=2; SelectedChip.PageSize=32; SelectedChip.Banks=1;
  SelectedChip.PWrite=true; //   
  BuildMemory();
  if(FileExists("i2c_prog_1.jpg")) Image1->Picture->LoadFromFile("i2c_prog_1.jpg");
  else                           { MessageBox(NULL,"   ,\n(   ).  \n ,    \n   radiohlam.ru","Error",MB_OK);
                                   Image1->Picture->Bitmap->FreeImage(); }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::AT24C1281Click(TObject *Sender)
{ SelectedChip.Name="AT24C128"; SelectedChip.Model=13; SelectedChip.Size=16384;
  SelectedChip.AddrSize=2; SelectedChip.PageSize=64; SelectedChip.Banks=1;
  SelectedChip.PWrite=true; //   
  BuildMemory();
  if(FileExists("i2c_prog_1.jpg")) Image1->Picture->LoadFromFile("i2c_prog_1.jpg");
  else                           { MessageBox(NULL,"   ,\n(   ).  \n ,    \n   radiohlam.ru","Error",MB_OK);
                                   Image1->Picture->Bitmap->FreeImage(); }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::AT24C2561Click(TObject *Sender)
{ SelectedChip.Name="AT24C256"; SelectedChip.Model=14; SelectedChip.Size=32768;
  SelectedChip.AddrSize=2; SelectedChip.PageSize=64; SelectedChip.Banks=1;
  SelectedChip.PWrite=true; //   
  BuildMemory();
  if(FileExists("i2c_prog_1.jpg")) Image1->Picture->LoadFromFile("i2c_prog_1.jpg");
  else                           { MessageBox(NULL,"   ,\n(   ).  \n ,    \n   radiohlam.ru","Error",MB_OK);
                                   Image1->Picture->Bitmap->FreeImage(); }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::AT24C5121Click(TObject *Sender)
{ SelectedChip.Name="AT24C512"; SelectedChip.Model=15; SelectedChip.Size=65536;
  SelectedChip.AddrSize=2; SelectedChip.PageSize=128; SelectedChip.Banks=1;
  SelectedChip.PWrite=true; //   
  BuildMemory();
  if(FileExists("i2c_prog_1.jpg")) Image1->Picture->LoadFromFile("i2c_prog_1.jpg");
  else                           { MessageBox(NULL,"   ,\n(   ).  \n ,    \n   radiohlam.ru","Error",MB_OK);
                                   Image1->Picture->Bitmap->FreeImage(); }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::PCF8582C21Click(TObject *Sender)
{ SelectedChip.Name="PCF8582-C2"; SelectedChip.Model=16; SelectedChip.Size=256;
  SelectedChip.AddrSize=1; SelectedChip.PageSize=8; SelectedChip.Banks=1;
  SelectedChip.PWrite=true; //   
  BuildMemory();
  if(FileExists("i2c_prog_1.jpg")) Image1->Picture->LoadFromFile("i2c_prog_1.jpg");
  else                           { MessageBox(NULL,"   ,\n(   ).  \n ,    \n   radiohlam.ru","Error",MB_OK);
                                   Image1->Picture->Bitmap->FreeImage(); }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::PCF8594C21Click(TObject *Sender)
{ SelectedChip.Name="PCF8594-C2"; SelectedChip.Model=17; SelectedChip.Size=512;
  SelectedChip.AddrSize=1; SelectedChip.PageSize=8; SelectedChip.Banks=2;
  SelectedChip.PWrite=true; //   
  BuildMemory();
  if(FileExists("i2c_prog_1.jpg")) Image1->Picture->LoadFromFile("i2c_prog_1.jpg");
  else                           { MessageBox(NULL,"   ,\n(   ).  \n ,    \n   radiohlam.ru","Error",MB_OK);
                                   Image1->Picture->Bitmap->FreeImage(); }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::PCF8598C21Click(TObject *Sender)
{ SelectedChip.Name="PCF8598-C2"; SelectedChip.Model=18; SelectedChip.Size=1024;
  SelectedChip.AddrSize=1; SelectedChip.PageSize=8; SelectedChip.Banks=4;
  SelectedChip.PWrite=true; //   
  BuildMemory();
  if(FileExists("i2c_prog_1.jpg")) Image1->Picture->LoadFromFile("i2c_prog_1.jpg");
  else                           { MessageBox(NULL,"   ,\n(   ).  \n ,    \n   radiohlam.ru","Error",MB_OK);
                                   Image1->Picture->Bitmap->FreeImage(); }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::RichEdit1KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{ int  PositionGlobal, LineNumber, PositionLocal;

  switch(PageControl1->TabIndex)
  { case 0: PositionGlobal=Form1->RichEdit1->SelStart;  //    
            break;
    case 1: PositionGlobal=Form1->RichEdit2->SelStart;  //    
            break;
    case 2: PositionGlobal=Form1->RichEdit3->SelStart;  //    
  }
  LineNumber=PositionGlobal/46;               //  ,      44  + CR+LF
  PositionLocal=PositionGlobal-46*LineNumber; //    
  int MaxLineNumber = (SelectedChip.Size-1)/8;  //   

  BS_FLAG=false;
  switch(Key)
   { //*********************************************************
     //   BackSpace ***************************
     case 8:  Key=0x25;
              //   
              if(PositionLocal==6)
              { if(LineNumber==0)  PositionGlobal=MaxLineNumber*46+29;
                else               PositionGlobal=(LineNumber-1)*46+29;
                Key=0;
              }
              if(PositionLocal==36)
              { if(LineNumber==0)  PositionGlobal=MaxLineNumber*46+44;
                else               PositionGlobal=(LineNumber-1)*46+44;
                Key=0;
              }
              switch(PageControl1->TabIndex)
              { case 0: Form1->RichEdit1->SelStart=PositionGlobal;   //  
                        Form1->RichEdit1->SelLength=0;               //  
                        break;
                case 1: Form1->RichEdit2->SelStart=PositionGlobal;   //  
                        Form1->RichEdit2->SelLength=0;               //  
                        break;
                case 2: Form1->RichEdit3->SelStart=PositionGlobal;   //  
                        Form1->RichEdit3->SelLength=0;               //  
              }
              //   BackSpace
              BS_FLAG=true;
              return;
     //*********************************************************
     //   Delete ******************************
     case 0x2E: ChangeLeftRight(PositionGlobal, PositionLocal, LineNumber, Key);
                //   
                if(PositionLocal==29)
                { if(LineNumber==MaxLineNumber)  PositionGlobal=5;
                  else                           PositionGlobal=(LineNumber+1)*46+5;
                }
                if(PositionLocal==44)
                { if(LineNumber==MaxLineNumber)  PositionGlobal=35;
                  else                           PositionGlobal=(LineNumber+1)*46+35;
                }
                switch(PageControl1->TabIndex)
                { case 0: Form1->RichEdit1->SelStart=PositionGlobal;   //  
                          Form1->RichEdit1->SelLength=0;               //  
                          break;
                  case 1: Form1->RichEdit2->SelStart=PositionGlobal;   //  
                          Form1->RichEdit2->SelLength=0;               //  
                          break;
                  case 2: Form1->RichEdit3->SelStart=PositionGlobal;   //  
                          Form1->RichEdit3->SelLength=0;               //  
                }
                Key=0x27;
                return;
     //*********************************************************
     //    *****************************
     case 0x25:
     case 0x26:
     case 0x27:
     case 0x28: return;
     //*********************************************************
     //     ***********************
     default:   Key=0;
                return;
   }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::RichEdit1KeyPress(TObject *Sender, char &Key)
{ int  PositionGlobal, LineNumber, PositionLocal;

  switch(PageControl1->TabIndex)
  { case 0: PositionGlobal=Form1->RichEdit1->SelStart;  //    
            break;
    case 1: PositionGlobal=Form1->RichEdit2->SelStart;  //    
            break;
    case 2: PositionGlobal=Form1->RichEdit3->SelStart;  //    
  }
  LineNumber=PositionGlobal/46;               //  ,      44  + CR+LF
  PositionLocal=PositionGlobal-46*LineNumber; //    
  //************************************************************
  //   Enter *****************************************
  if(Key==0x0D)
  { Key=0;     //  Enter
    return;    //  
  }
  //************************************************************
  //   BackSpace     ************
  ChangeLeftRight(PositionGlobal, PositionLocal, LineNumber, Key);
  if(BS_FLAG) return; //    BackSpace
  //  -  ****************************************
  int MaxLineNumber = (SelectedChip.Size-1)/8;
  if(PositionLocal==29)
  { if(LineNumber==MaxLineNumber)  PositionGlobal=5;
    else                           PositionGlobal=(LineNumber+1)*46+5;
    switch(PageControl1->TabIndex)
    { case 0: Form1->RichEdit1->SelStart=PositionGlobal;   //  
              Form1->RichEdit1->SelLength=0;               //  
              break;
      case 1: Form1->RichEdit2->SelStart=PositionGlobal;   //  
              Form1->RichEdit2->SelLength=0;               //  
              break;
      case 2: Form1->RichEdit3->SelStart=PositionGlobal;   //  
              Form1->RichEdit3->SelLength=0;               //  
    }
  }
  if(PositionLocal==44)
  { if(LineNumber==MaxLineNumber)  PositionGlobal=35;
    else                           PositionGlobal=(LineNumber+1)*46+35;
    switch(PageControl1->TabIndex)
    { case 0: Form1->RichEdit1->SelStart=PositionGlobal;   //  
              Form1->RichEdit1->SelLength=0;               //  
              break;
      case 1: Form1->RichEdit2->SelStart=PositionGlobal;   //  
              Form1->RichEdit2->SelLength=0;               //  
              break;
      case 2: Form1->RichEdit3->SelStart=PositionGlobal;   //  
              Form1->RichEdit3->SelLength=0;               //  
    }
  }
  Key=0;
  keybd_event(VK_RIGHT,0,0,0);
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//***************************************************************************
//---   -----------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{ unsigned char buf[2], value[1];
  AnsiString TempStr;
  Byte CurrentBank;           //  ,  
  int  BankSize, CurrentAddr, StartPageAddr; //  ,    ,     
  int  GlobalNumber, BlockNumber, BlockPosition; //  ,  8- ,   8- 
  Byte BlocksInPage;          //  8-   

  // -
  Application->CreateForm(__classid(TLBar),&LBar); //    -
  LBar->Show();                   //     

  //*************************************************************************
  // WRITE WITHOUT CONTROL **************************************************
  //***********************************************************************
  // PAGE WRITE ***********************************************************
  if(CheckBox2->Checked==true)
  { //c   
    for(int i=0; i<SelectedChip.Size/SelectedChip.PageSize; i++)
    { //  -
      wr_buf_len=1;
      wr_buf[0]=0x20; // Send START
      if(!WriteTo()) { MessageBox(NULL," ","Error",MB_OK);
                       LBar->Free();  //    -
                       ClosePort();   //  
                       return; }
      //     
      if(SelectedChip.Model) // ,  X24C01
      { wr_buf_len=2;
        wr_buf[0]=0x22;                       // Send Byte
        CurrentBank=i*SelectedChip.PageSize/pow(256,SelectedChip.AddrSize);//    (  = 256^AddrSize)
        wr_buf[1]=(CurrentBank<<1)|0xA0;      // Device Address
        if(!WriteTo()) { MessageBox(NULL," ","Error",MB_OK);
                         LBar->Free();  //    -
                         ClosePort();   //  
                         return; }
        //   
        StartPageAddr=SelectedChip.PageSize*i-pow(256,SelectedChip.AddrSize)*CurrentBank; //      
        switch(SelectedChip.AddrSize)
        { case 1:  //   
                   wr_buf_len=2;
                   wr_buf[0]=0x22;                // Send Byte
                   wr_buf[1]=StartPageAddr;
                   if(!WriteTo()) { MessageBox(NULL," ","Error",MB_OK);
                                    LBar->Free();        //    -
                                    ClosePort();   //  
                                    return; }
                   break;
          case 2:  //   
                   wr_buf_len=2;
                   wr_buf[0]=0x22;             // Send Byte
                   wr_buf[1]=StartPageAddr>>8; //   
                   if(!WriteTo()) { MessageBox(NULL," ","Error",MB_OK);
                                    LBar->Free();        //    -
                                    ClosePort();   //  
                                    return; }
                   Sleep(1);
                   wr_buf_len=2;
                   wr_buf[0]=0x22;           // Send Byte
                   wr_buf[1]=StartPageAddr;  //   
                   if(!WriteTo()) { MessageBox(NULL," ","Error",MB_OK);
                                    LBar->Free();        //    -
                                    ClosePort();   //  
                                    return; }
        }
      }
      else //for X24C01
      { wr_buf_len=2;
        wr_buf[0]=0x22;                // Send Byte
        wr_buf[1]=(StartPageAddr<1)&0xFE; //     0- 
        if(!WriteTo()) { MessageBox(NULL," ","Error",MB_OK);
                         LBar->Free();        //    -
                         ClosePort();   //  
                         return; }
      }
      //     PageSize 
      BlocksInPage=SelectedChip.PageSize/8; //  8-   
      for(int j=0; j<BlocksInPage; j++)  // j -   8-   
      { for(int k=0; k<8; k++)
        { LBar->ProgressBar1->Position=100*((i*BlocksInPage+j)*8+k)/SelectedChip.Size; //    -
          //   = BlocksInPage*i+j
          switch(PageControl1->TabIndex)
          { case 0: Form1->RichEdit1->SelStart=(i*BlocksInPage+j)*46+6+3*k; //     
                    Form1->RichEdit1->SelLength=2;                 //  2 
                    TempStr=LowerCase(Form1->RichEdit1->SelText);  //    
                    Form1->RichEdit1->SelLength=0;                 //  
                    break;
            case 1: Form1->RichEdit2->SelStart=(i*BlocksInPage+j)*46+6+3*k; //     
                    Form1->RichEdit2->SelLength=2;                 //  2 
                    TempStr=LowerCase(Form1->RichEdit2->SelText);  //    
                    Form1->RichEdit2->SelLength=0;                 //  
                    break;
            case 2: Form1->RichEdit3->SelStart=(i*BlocksInPage+j)*46+6+3*k; //     
                    Form1->RichEdit3->SelLength=2;                 //  2 
                    TempStr=LowerCase(Form1->RichEdit3->SelText);  //    
                    Form1->RichEdit3->SelLength=0;                 //  
          }
          memset(buf,0,2);                               //  
          strcat(buf,TempStr.c_str());                   //      (  )
          HexToBin(buf,value,1);                         //    ()
          wr_buf_len=2;
          wr_buf[0]=0x22;      // Send Byte
          wr_buf[1]=value[0];  // Data
          if(!WriteTo()) { MessageBox(NULL," ","Error",MB_OK);
                           LBar->Free();        //    -
                           ClosePort();   //  
                           return; }
        }
      }
      // -  ,    
      wr_buf_len=1;
      wr_buf[0]=0x21; // Send STOP
      if(!WriteTo()) { MessageBox(NULL," ","Error",MB_OK);
                       LBar->Free();        //    -
                       ClosePort();   //  
                       return; }
      switch(SelectedChip.Model)
      { case 0: case 1: case 2: case 3: case 4: case 5: case 6: case 7: case 8:
        case 9: case 10: case 11: case 12: case 13: case 14: case 15: case 19:
                Sleep(11); //    5-10 ,   
                break;
        case 16: case 17: case 18:
                Sleep(32); // PCF - 
      }
    }
  }
  //***********************************************************************
  // BYTE WRITE ***********************************************************
  else
  { //    
    for(CurrentBank=0; CurrentBank<SelectedChip.Banks; CurrentBank++)
    { //     (   ,      )
      switch(SelectedChip.Model)
      { case 0: case 1:
                 BankSize=128;
                 break;
        case 2: case 3: case 4: case 5: case 6: case 7: case 8: case 9: case 10: case 16: case 17: case 18:
                 BankSize=256;
                 break;
        case 19: BankSize=2048;
                 break;
        case 11: BankSize=4096;
                 break;
        case 12: BankSize=8192;
                 break;
        case 13: BankSize=16384;
                 break;
        case 14: BankSize=32768;
                 break;
        case 15: BankSize=65536;
      }
      for(CurrentAddr=0; CurrentAddr<BankSize; CurrentAddr++)
      { //  -
        wr_buf_len=1;
        wr_buf[0]=0x20; // Send START
        if(!WriteTo()) { MessageBox(NULL," ","Error",MB_OK);
                         LBar->Free(); //    -
                         ClosePort();   //  
                         return; }
        //Sleep(1);
        //     
        if(SelectedChip.Model)  //  ,  X24C01
        { wr_buf_len=2;
          wr_buf[0]=0x22;                       // Send Byte
          switch(SelectedChip.Model)
          { case 1: case 2: case 3: case 4: case 5: case 16: case 17: case 18:  //  24-    
                    wr_buf[1]=(CurrentBank<<1)|0xA0; // Device Address
                    break;
            case 6: case 7: case 8: case 9: case 10:      //  SDA
                    wr_buf[1]=((CurrentBank<<2)|2)|0xA0;  // Device Address for SDA2546 (Bit0=0, Bit1=CS (   1), Bit2 -  ),      2  ,  ""  2 (1- =1),  ""  0xA0
                    break;
            case 11: case 12: case 13: case 14: case 15: case 19:  //  24-    
                    wr_buf[1]=(CurrentBank<<1)|0xA0; // Device Address
                    break;
          }
          if(!WriteTo()) { MessageBox(NULL," ","Error",MB_OK);
                           LBar->Free();        //    -
                           ClosePort();   //  
                           return; }
          //Sleep(1);
          //    
          switch(SelectedChip.AddrSize)
          { case 1: //     
                    wr_buf_len=2;
                    wr_buf[0]=0x22;            // Send Byte
                    wr_buf[1]=CurrentAddr;     // Byte Address
                    if(!WriteTo()) { MessageBox(NULL," ","Error",MB_OK);
                                     LBar->Free();  //    -
                                     ClosePort();   //  
                                     return; }
                    break;
            case 2: //     
                    wr_buf_len=2;
                    wr_buf[0]=0x22;            // Send Byte
                    wr_buf[1]=CurrentAddr>>8;  // Byte High Address
                    if(!WriteTo()) { MessageBox(NULL," ","Error",MB_OK);
                                     LBar->Free();  //    -
                                     ClosePort();   //  
                                     return; }
                    Sleep(1);
                    wr_buf_len=2;
                    wr_buf[0]=0x22;            // Send Byte
                    wr_buf[1]=CurrentAddr;     // Byte Low Address
                    if(!WriteTo()) { MessageBox(NULL," ","Error",MB_OK);
                                     LBar->Free();  //    -
                                     ClosePort();   //  
                                     return; }
          }
        }
        else //  X24C01
        { wr_buf_len=2;
          wr_buf[0]=0x22;                // Send Byte
          wr_buf[1]=(CurrentAddr<1)&0xFE; //     0- 
          if(!WriteTo()) { MessageBox(NULL," ","Error",MB_OK);
                           LBar->Free();        //    -
                           ClosePort();   //  
                           return; }
        }
        //Sleep(1);
        //    
        GlobalNumber=CurrentBank*BankSize+CurrentAddr;
        BlockNumber=GlobalNumber/8;
        BlockPosition=GlobalNumber-BlockNumber*8;
        //  -
        LBar->ProgressBar1->Position=100*GlobalNumber/SelectedChip.Size; //    -
        switch(PageControl1->TabIndex)
        { case 0: Form1->RichEdit1->SelStart=BlockNumber*46+6+3*BlockPosition;//     
                  Form1->RichEdit1->SelLength=2;                 //  2 
                  TempStr=LowerCase(Form1->RichEdit1->SelText);  //    
                  Form1->RichEdit1->SelLength=0;                 //  
                  break;
          case 1: Form1->RichEdit2->SelStart=BlockNumber*46+6+3*BlockPosition;//     
                  Form1->RichEdit2->SelLength=2;                 //  2 
                  TempStr=LowerCase(Form1->RichEdit2->SelText);  //    
                  Form1->RichEdit2->SelLength=0;                 //  
                  break;
          case 2: Form1->RichEdit3->SelStart=BlockNumber*46+6+3*BlockPosition;//     
                  Form1->RichEdit3->SelLength=2;                 //  2 
                  TempStr=LowerCase(Form1->RichEdit3->SelText);  //    
                  Form1->RichEdit3->SelLength=0;                 //  
        }
        memset(buf,0,2);                               //  
        strcat(buf,TempStr.c_str());                   //      (  )
        HexToBin(buf,value,1);                         //    ()
        // ,   
        wr_buf_len=2;
        wr_buf[0]=0x22;     // Send Byte
        wr_buf[1]=value[0]; // Byte
        if(!WriteTo()) { MessageBox(NULL," ","Error",MB_OK);
                         LBar->Free();        //    -
                         ClosePort();   //  
                         return; }
        // -
        wr_buf_len=1;
        wr_buf[0]=0x21; // Send STOP
        if(!WriteTo()) { MessageBox(NULL," ","Error",MB_OK);
                         LBar->Free();        //    -
                         ClosePort();   //  
                         return; }
        Sleep(11); // ,   
      }
    }
  }
  //*************************************************************************
  LBar->Free();        //    -
  MessageBox(NULL," ","OK",MB_OK);
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//***************************************************************************
//---   -----------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{ char buf[2], value[1], hexbuf[3];
  AnsiString TempStr;
  Byte CurrentBank;    //  
  int  BankSize, CurrentAddr; //  ,    
  int  GlobalNumber, BlockNumber, BlockPosition;  //  ,  8- ,   8- 

  // -
  Application->CreateForm(__classid(TLBar),&LBar); //    -
  LBar->Show();                   //     
  //*************************************************************************
  // READ WITHOUT CONTROL ***************************************************
  //    
  for(CurrentBank=0; CurrentBank<SelectedChip.Banks; CurrentBank++)
  { if(SelectedChip.Model) //  ,  X24C01
    { //  -
      wr_buf_len=1;
      wr_buf[0]=0x20; // Send START
      if(!WriteTo()) { MessageBox(NULL," ","Error",MB_OK);
                       LBar->Free(); //    -
                       ClosePort();   //  
                       return; }
      // Sleep(1);/////////////////////////////////////////
      //     
      wr_buf_len=2;
      wr_buf[0]=0x22;                       // Send Byte
      switch(SelectedChip.Model)
      { case 1: case 2: case 3: case 4: case 5: case 16: case 17: case 18:   //  24-    
                 wr_buf[1]=(CurrentBank<<1)|0xA0; // Device Address
                 break;
        case 6: case 7: case 8: case 9: case 10:      //  SDA
                 wr_buf[1]=((CurrentBank<<2)|2)|0xA0; // Device Address for SDA2546 (Bit0=0, Bit1=CS (   1), Bit2 -  ),      2  ,  ""  2 (1- =1),  ""  0xA0
                 break;
        case 11: case 12: case 13: case 14: case 15: case 19:  //  24-    
                  wr_buf[1]=(CurrentBank<<1)|0xA0; // Device Address
      }
      if(!WriteTo()) { MessageBox(NULL," ","Error",MB_OK);
                       LBar->Free();        //    -
                       ClosePort();   //  
                       return; }
      // Sleep(1);/////////////////////////////////////////
      //   
      switch(SelectedChip.AddrSize)
      { case 1: //   
                wr_buf_len=2;
                wr_buf[0]=0x22;         // Send Byte
                wr_buf[1]=0;            //   
                if(!WriteTo()) { MessageBox(NULL," ","Error",MB_OK);
                                 LBar->Free();        //    -
                                 ClosePort();   //  
                                 return; }
                break;
        case 2: wr_buf_len=2;
                wr_buf[0]=0x22;         // Send Byte
                wr_buf[1]=0;            //    ( )
                if(!WriteTo()) { MessageBox(NULL," ","Error",MB_OK);
                                 LBar->Free();        //    -
                                 ClosePort();   //  
                                 return; }
                Sleep(1);
                wr_buf_len=2;
                wr_buf[0]=0x22;         // Send Byte
                wr_buf[1]=0;            //    ( )
                if(!WriteTo()) { MessageBox(NULL," ","Error",MB_OK);
                                 LBar->Free();        //    -
                                 ClosePort();   //  
                                 return; }
      }
    }
    // Sleep(1);/////////////////////////////////////////
    //  
    wr_buf_len=1;
    wr_buf[0]=0x20; // Send START
    if(!WriteTo()) { MessageBox(NULL," ","Error",MB_OK);
                     LBar->Free();        //    -
                     ClosePort();   //  
                     return; }
    // Sleep(1);/////////////////////////////////////////
    //     
    wr_buf_len=2;
    wr_buf[0]=0x22;                       // Send Byte
    switch(SelectedChip.Model)
    { case 0: case 1:  case 2: case 3: case 4: case 5: case 16: case 17: case 18:  //  24-  c  
               wr_buf[1]=(CurrentBank<<1)|0xA1; // Device Read
               break;
      case 6:  case 7: case 8: case 9: case 10:      //  SDA
               wr_buf[1]=((CurrentBank<<2)|2)|0xA1;  // Device Address for SDA
               break;
      case 11: case 12: case 13: case 14: case 15: case 19:   //  24-  c  
               wr_buf[1]=(CurrentBank<<1)|0xA1; // Device Read
    }
    if(!WriteTo()) { MessageBox(NULL," ","Error",MB_OK);
                     LBar->Free();        //    -
                     ClosePort();   //  
                     return; }
    // Sleep(1);/////////////////////////////////////////
    //     (   ,      )
    switch(SelectedChip.Model)
    { case 0: case 1:
               BankSize=128;
               break;
      case 2: case 3: case 4: case 5: case 6: case 7: case 8: case 9: case 10: case 16: case 17: case 18:
               BankSize=256;
               break;
      case 19: BankSize=2048;
               break;
      case 11: BankSize=4096;
               break;
      case 12: BankSize=8192;
               break;
      case 13: BankSize=16384;
               break;
      case 14: BankSize=32768;
               break;
      case 15: BankSize=65536;
    }
    for(CurrentAddr=0; CurrentAddr<BankSize; CurrentAddr++)
    { wr_buf_len=1;
      if(CurrentAddr==(BankSize-1)) wr_buf[0]=0x24;      // Read withoutACK sequence
      else                          wr_buf[0]=0x23;      // Read withACK sequence
      if(!WriteTo()) { MessageBox(NULL," ","Error",MB_OK);
                       LBar->Free();        //    -
                       ClosePort();   //  
                       return; }
      //   
      if(!ReadFrom()) { MessageBox(NULL," ","Error",MB_OK);
                        LBar->Free();        //    -
                        ClosePort();   //  
                        return; }
      //     
         GlobalNumber=CurrentBank*BankSize+CurrentAddr;
         BlockNumber=GlobalNumber/8;
         BlockPosition=GlobalNumber-BlockNumber*8;
      //  -
      LBar->ProgressBar1->Position=100*GlobalNumber/SelectedChip.Size; //    -
      //   
         memset(buf,0,2);                 //  
         buf[0]=rd_buf[0];                //     
         if(rd_buf[0]<0x1F) buf[0]=0x1F;  //,  
         switch(PageControl1->TabIndex)
         { case 0: Form1->RichEdit1->SelStart=BlockNumber*46+36+BlockPosition; //        
                   Form1->RichEdit1->SelLength=1;           //  1 
                   Form1->RichEdit1->SelText=buf;           //    
                   break;
           case 1: Form1->RichEdit2->SelStart=BlockNumber*46+36+BlockPosition; //        
                   Form1->RichEdit2->SelLength=1;           //  1 
                   Form1->RichEdit2->SelText=buf;           //    
                   break;
           case 2: Form1->RichEdit3->SelStart=BlockNumber*46+36+BlockPosition; //        
                   Form1->RichEdit3->SelLength=1;           //  1 
                   Form1->RichEdit3->SelText=buf;           //    
         }
      //  
         value[0]=rd_buf[0];
         BinToHex(value,hexbuf,1);                       //    ()
         hexbuf[2]=0;                                    //   
         switch(PageControl1->TabIndex)
         { case 0: Form1->RichEdit1->SelStart=BlockNumber*46+6+3*BlockPosition; //     
                   Form1->RichEdit1->SelLength=2;                  //  2 
                   Form1->RichEdit1->SelText=hexbuf;
                   break;
           case 1: Form1->RichEdit2->SelStart=BlockNumber*46+6+3*BlockPosition; //     
                   Form1->RichEdit2->SelLength=2;                  //  2 
                   Form1->RichEdit2->SelText=hexbuf;
                   break;
           case 2: Form1->RichEdit3->SelStart=BlockNumber*46+6+3*BlockPosition; //     
                   Form1->RichEdit3->SelLength=2;                  //  2 
                   Form1->RichEdit3->SelText=hexbuf;
         }
      // Sleep(1);///////////////////////////////////////
    }
    // -
    wr_buf_len=1;
    wr_buf[0]=0x21; // Send STOP
    if(!WriteTo()) { MessageBox(NULL," ","Error",MB_OK);
                     LBar->Free();        //    -
                     ClosePort();   //  
                     return; }
    // Sleep(1); //     
  }
  //*************************************************************************
  LBar->Free();        //    -
  MessageBox(NULL," ","OK",MB_OK);
}
//---------------------------------------------------------------------------
//---     ------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Open1Click(TObject *Sender)
{ int Namelength; AnsiString Ext;
  char buf[2], value[1], hexbuf[3]; unsigned char rffch[1]; // readed from file char
  AnsiString TempStr;
  int  BlockNumber, BlockPosition;  //  ,  8- ,   8- 

  if(OpenDialog1->Execute())
  { FilePath=OpenDialog1->FileName;          //    
    Namelength=FilePath.Length();            //      
    Ext=FilePath.SubString(Namelength-2,3);  // 
    Ext=UpperCase(Ext);                      //    

    //  hex-
    if(Ext=="HEX")
    { Memo1->Lines->LoadFromFile(FilePath);
      LoadHexFile();
      Memo1->Clear();
    }
    //  bin-
    else
    { TFileStream* fs=new TFileStream(FilePath,fmOpenRead);
      for(int i=0; i<SelectedChip.Size; i++)
      { BlockNumber=i/8; BlockPosition=i-BlockNumber*8;
        if(fs->Read(rffch,1))  //    
        { //   
          memset(buf,0,2);             //  
          buf[0]=rffch[0];                //     
          if(rffch[0]<0x1F) buf[0]=0x1F;  //,  
          switch(PageControl1->TabIndex)
          { case 0: Form1->RichEdit1->SelStart=BlockNumber*46+36+BlockPosition; //        
                    Form1->RichEdit1->SelLength=1;           //  1 
                    Form1->RichEdit1->SelText=buf;           //    
                    break;
            case 1: Form1->RichEdit2->SelStart=BlockNumber*46+36+BlockPosition; //        
                    Form1->RichEdit2->SelLength=1;           //  1 
                    Form1->RichEdit2->SelText=buf;           //    
                    break;
            case 2: Form1->RichEdit3->SelStart=BlockNumber*46+36+BlockPosition; //        
                    Form1->RichEdit3->SelLength=1;           //  1 
                    Form1->RichEdit3->SelText=buf;           //    
          }
          //  
          value[0]=rffch[0];
          BinToHex(value,hexbuf,1);                       //    ()
          hexbuf[2]=0;                                    //   
          switch(PageControl1->TabIndex)
          { case 0: Form1->RichEdit1->SelStart=BlockNumber*46+6+3*BlockPosition; //     
                    Form1->RichEdit1->SelLength=2;                  //  2 
                    Form1->RichEdit1->SelText=hexbuf;
                    break;
            case 1: Form1->RichEdit2->SelStart=BlockNumber*46+6+3*BlockPosition; //     
                    Form1->RichEdit2->SelLength=2;                  //  2 
                    Form1->RichEdit2->SelText=hexbuf;
                    break;
            case 2: Form1->RichEdit3->SelStart=BlockNumber*46+6+3*BlockPosition; //     
                    Form1->RichEdit3->SelLength=2;                  //  2 
                    Form1->RichEdit3->SelText=hexbuf;
          }
        }
        else i=SelectedChip.Size; //   
      }
      Form1->StaticText1->Caption=FilePath;
      delete fs;
    }
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Save1Click(TObject *Sender)
{ char buf[2], value[1];
  AnsiString TempStr;
  int  BlockNumber, BlockPosition;  //  ,  8- ,   8- 

  if(SaveDialog1->Execute()) //     
  { TFileStream* fs=new TFileStream(SaveDialog1->FileName,fmCreate|fmOpenWrite);
    FilePath=SaveDialog1->FileName;
    for(int i=0; i<SelectedChip.Size; i++)
    { BlockNumber=i/8; BlockPosition=i-BlockNumber*8;
      switch(PageControl1->TabIndex)
      { case 0: Form1->RichEdit1->SelStart=BlockNumber*46+6+3*BlockPosition;//     
                Form1->RichEdit1->SelLength=2;                 //  2 
                TempStr=LowerCase(Form1->RichEdit1->SelText);  //    
                Form1->RichEdit1->SelLength=0;                 //  
                break;
        case 1: Form1->RichEdit2->SelStart=BlockNumber*46+6+3*BlockPosition;//     
                Form1->RichEdit2->SelLength=2;                 //  2 
                TempStr=LowerCase(Form1->RichEdit2->SelText);  //    
                Form1->RichEdit2->SelLength=0;                 //  
                break;
        case 2: Form1->RichEdit3->SelStart=BlockNumber*46+6+3*BlockPosition;//     
                Form1->RichEdit3->SelLength=2;                 //  2 
                TempStr=LowerCase(Form1->RichEdit3->SelText);  //    
                Form1->RichEdit3->SelLength=0;                 //  
      }
      memset(buf,0,2);                               //  
      strcat(buf,TempStr.c_str());                   //      (  )
      HexToBin(buf,value,1);                         //    ()
      fs->Write(value,1);                            //  
    }
    Form1->StaticText1->Caption=FilePath;
    delete fs;
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Save2Click(TObject *Sender)
{ char buf[2], value[1];  int Namelength;
  AnsiString TempStr, Ext;
  int  BlockNumber, BlockPosition;  //  ,  8- ,   8- 
  TFileStream* fs;
  bool NeedSave;

  NeedSave=false;
  Namelength=FilePath.Length();            //      
  Ext=FilePath.SubString(Namelength-2,3);  // 
  Ext=UpperCase(Ext);                      //    

  if(FilePath.Length()&&(Ext=="BIN"))      //     
  { if(MessageBox(Form1->Handle,"   , ?","", MB_OKCANCEL|MB_ICONQUESTION)==IDOK)
    { fs=new TFileStream(FilePath,fmCreate|fmOpenWrite);
      NeedSave=true;
    }
  }
  else if(SaveDialog1->Execute()) //     (  )
  { fs=new TFileStream(SaveDialog1->FileName,fmCreate|fmOpenWrite);
    FilePath=SaveDialog1->FileName;
    NeedSave=true;
  }
  if(NeedSave)         //   
  { for(int i=0; i<SelectedChip.Size; i++)
    { BlockNumber=i/8; BlockPosition=i-BlockNumber*8;
      switch(PageControl1->TabIndex)
      { case 0: Form1->RichEdit1->SelStart=BlockNumber*46+6+3*BlockPosition;//     
                Form1->RichEdit1->SelLength=2;                 //  2 
                TempStr=LowerCase(Form1->RichEdit1->SelText);  //    
                Form1->RichEdit1->SelLength=0;                 //  
                break;
        case 1: Form1->RichEdit2->SelStart=BlockNumber*46+6+3*BlockPosition;//     
                Form1->RichEdit2->SelLength=2;                 //  2 
                TempStr=LowerCase(Form1->RichEdit2->SelText);  //    
                Form1->RichEdit2->SelLength=0;                 //  
                break;
        case 2: Form1->RichEdit3->SelStart=BlockNumber*46+6+3*BlockPosition;//     
                Form1->RichEdit3->SelLength=2;                 //  2 
                TempStr=LowerCase(Form1->RichEdit3->SelText);  //    
                Form1->RichEdit3->SelLength=0;                 //  
      }
      memset(buf,0,2);                               //  
      strcat(buf,TempStr.c_str());                   //      (  )
      HexToBin(buf,value,1);                         //    ()
      fs->Write(value,1);                            //  
    }
    Form1->StaticText1->Caption=FilePath;
    delete fs;
  }
}
//---------------------------------------------------------------------------
