//---------------------------------------------------------------------------
// http://radiohlam.ru
#ifndef Unit1H
#define Unit1H
#define BUFSIZE 1024
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <Menus.hpp>
#include <ComCtrls.hpp>
#include <jpeg.hpp>
#include <math.h>
#include <Dialogs.hpp>
//---------------------------------------------------------------------------
  DCB    dcb;                   //  DCB
  HANDLE Port;                  //  
  OVERLAPPED ovr_wr, ovr_rd;
  AnsiString FilePath;

  unsigned char wr_buf[BUFSIZE], rd_buf[BUFSIZE]; //   
  int  wr_buf_len, rd_buf_len;
  bool BS_FLAG;

  struct chip { AnsiString Name; int Model, Size; Byte AddrSize, PageSize, Banks; bool PWrite;} SelectedChip; 

bool WriteTo(void);
bool ReadFrom(void);
void OpenPort(void);
void ClosePort(void);
void BuidMemory(void);
void LoadHexFile(void);
void ChangeLeftRight(int PositionGlobal, int PositionLocal, int LineNumber, char Key);
//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// IDE-managed Components
        TMainMenu *MainMenu1;
        TMenuItem *File1;
        TMenuItem *Exit1;
        TMenuItem *ChipSelect1;
        TMenuItem *Help1;
        TMenuItem *About1;
        TMenuItem *N24C011;
        TMenuItem *N24C021;
        TMenuItem *N24C041;
        TMenuItem *N24C081;
        TMenuItem *N24C161;
        TMenuItem *SDA25161;
        TMenuItem *SDA25261;
        TMenuItem *SDA25461;
        TPanel *Panel1;
        TButton *Button1;
        TButton *Button2;
        TEdit *Edit1;
        TButton *Button3;
        TButton *Button4;
        TComboBox *ComboBox1;
        TCheckBox *CheckBox2;
        TPageControl *PageControl1;
        TTabSheet *TabSheet1;
        TRichEdit *RichEdit1;
        TTabSheet *TabSheet2;
        TTabSheet *TabSheet3;
        TRichEdit *RichEdit2;
        TRichEdit *RichEdit3;
        TMenuItem *SDA25861;
        TMenuItem *N1;
        TMenuItem *N24C321;
        TMenuItem *N24C641;
        TImage *Image1;
        TMenuItem *N2;
        TMenuItem *AT24C1281;
        TMenuItem *AT24C2561;
        TMenuItem *AT24C5121;
        TMenuItem *N3;
        TMenuItem *X24C011;
        TMenuItem *SDA35261;
        TMenuItem *N4;
        TMenuItem *PCF8582C21;
        TMenuItem *PCF8594C21;
        TMenuItem *PCF8598C21;
        TOpenDialog *OpenDialog1;
        TMenuItem *Open1;
        TMemo *Memo1;
        TSaveDialog *SaveDialog1;
        TMenuItem *Save1;
        TMenuItem *N5;
        TPanel *Panel2;
        TMenuItem *Save2;
        TStaticText *StaticText1;
        TMenuItem *N2425E161;
        void __fastcall Button3Click(TObject *Sender);
        void __fastcall Button4Click(TObject *Sender);
        void __fastcall ComboBox1Change(TObject *Sender);
        void __fastcall Exit1Click(TObject *Sender);
        void __fastcall About1Click(TObject *Sender);
        void __fastcall N24C011Click(TObject *Sender);
        void __fastcall N24C021Click(TObject *Sender);
        void __fastcall N24C041Click(TObject *Sender);
        void __fastcall N24C081Click(TObject *Sender);
        void __fastcall N24C161Click(TObject *Sender);
        void __fastcall SDA25161Click(TObject *Sender);
        void __fastcall SDA25261Click(TObject *Sender);
        void __fastcall SDA25461Click(TObject *Sender);
        void __fastcall RichEdit1KeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
        void __fastcall RichEdit1KeyPress(TObject *Sender, char &Key);
        void __fastcall Button2Click(TObject *Sender);
        void __fastcall Button1Click(TObject *Sender);
        void __fastcall SDA25861Click(TObject *Sender);
        void __fastcall N24C321Click(TObject *Sender);
        void __fastcall N24C641Click(TObject *Sender);
        void __fastcall AT24C1281Click(TObject *Sender);
        void __fastcall AT24C2561Click(TObject *Sender);
        void __fastcall AT24C5121Click(TObject *Sender);
        void __fastcall X24C011Click(TObject *Sender);
        void __fastcall SDA35261Click(TObject *Sender);
        void __fastcall PCF8582C21Click(TObject *Sender);
        void __fastcall PCF8594C21Click(TObject *Sender);
        void __fastcall PCF8598C21Click(TObject *Sender);
        void __fastcall Open1Click(TObject *Sender);
        void __fastcall Save1Click(TObject *Sender);
        void __fastcall Save2Click(TObject *Sender);
        void __fastcall N2425E161Click(TObject *Sender);
private:	// User declarations
public:		// User declarations
        __fastcall TForm1(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
